using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Tonyu
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {

        }

        private void Form2_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop) == true)
            {
                e.Effect = DragDropEffects.Copy;
            }
        }

        private void Form2_DragDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop) == true)
            {
                e.Effect = DragDropEffects.Copy;

                //pX擾
                string path = (e.Data.GetData(DataFormats.FileDrop) as string[])[0];
                if (File.Exists(path))
                    path = Path.GetDirectoryName(path);

                CheckRuntimeDirectory(path);
                return;
            }
        }

        private void CheckRuntimeDirectory(string path)
        {
            if (Directory.Exists(Path.Combine(path, "Program")))
                path = Path.Combine(path, "Program");

            tsslabel_Status.Text = "fBNgmFĂ܂B";

            //UsrfBNgmF
            if (Directory.Exists(Path.Combine(path, "Usr")) == false)
            {
                tsslabel_Status.Text = "UsrfBNg܂B";
                return;
            }

            //XNvgmF
            bool tonyuFileAvabable = false;
            foreach (string file in Directory.GetFiles(Path.Combine(path, "Usr"), "*.tonyu", SearchOption.TopDirectoryOnly))
                tonyuFileAvabable = true;
            if (tonyuFileAvabable == false)
            {
                tsslabel_Status.Text = "XNvgt@C܂B";
                return;
            }

            //KernelfBNgmF
            if (Directory.Exists(Path.Combine(path, "Kernel")) == false)
            {
                tsslabel_Status.Text = "KernelfBNg܂B";
                return;
            }

            tbox_Path.Text = path;
            btn_Start.Enabled = true;
            tsslabel_Status.Text = "Jn{^ĂB";

            return;
        }

        private void btn_Browse_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.OK)
            {
                string path = folderBrowserDialog.SelectedPath;
                CheckRuntimeDirectory(path);
            }
        }

        private void btn_Start_Click(object sender, EventArgs e)
        {
            tspbar_Marquee.Visible = true;

            int fcount = 0;
            int dietsize = 0;
            string path = Path.Combine(tbox_Path.Text,"Usr");
            string pattern = "*.tonyu";

            //*.tonyut@C//
            foreach (string file in Directory.GetFiles(path, pattern))
            {
                //t@CJEg//
                fcount++;
                tsslabel_Status.Text = string.Format("{0}ڂ̃t@CĂ܂B{1}oCgeʌ܂B",fcount,dietsize);

                try
                {
                    //f[^ǂݍ//
                    StreamReader reader = new StreamReader(file, Encoding.Default);
                    string[] filedata = new string[5000];
                    string line;
                    int lcount = 0;
                    while ((line = reader.ReadLine()) != null)
                    {
                        //ϊOf[^
                        int size1 = line.Length;

                        //ÕXy[X폜//
                        if (clbox_Functions.GetItemChecked(1))
                            line = line.Trim();

                        int srashIndex = line.IndexOf("//");
                        //Rg폜//
                        if (srashIndex > 0)
                            line = line.Substring(0, srashIndex);
                        else if (srashIndex == 0)
                            line = "";

                        //ϊf[^
                        int size2 = line.Length;

                        filedata[lcount] = line;
                        lcount++;

                        int diet = size1 - size2;
                        dietsize += diet;

                    }
                    reader.Close();

                    this.Update();
                    System.Threading.Thread.Sleep(8);

                    //f[^//
                    StreamWriter writer = new StreamWriter(new FileStream(file, FileMode.Create), Encoding.Default);
                    for (int i = 0; i < lcount; i++)
                    {
                        //s폜ȂAo
                        if (clbox_Functions.GetItemChecked(0))
                            writer.Write(filedata[i]);
                        else
                            writer.WriteLine(filedata[i]);
                    }

                    FileAttributes attr = 0;
                    //ǂݎp//
                    if (clbox_Functions.GetItemChecked(2))
                        attr |= FileAttributes.ReadOnly;
                    //Bt@C//
                    if (clbox_Functions.GetItemChecked(3))
                        attr |= FileAttributes.Hidden;
                    File.SetAttributes(file, attr);

                    writer.Close();
                }
                catch
                {
                    tsslabel_Status.Text = string.Format("{0}ڂ̃t@CĂ܂Bt@Cɏ߂܂B", fcount, dietsize);
                }
                System.Threading.Thread.Sleep(8);
            }

            tspbar_Marquee.Visible = false;
            tbox_Path.Text = "";
            btn_Start.Enabled = false;
            tsslabel_Status.Text = string.Format("܂B{0}oCgeʂ܂B",dietsize);

            MessageBox.Show("܂I");
        }
    }
}